<Serializable()> Public Class CustomAppException
Inherits BaseApplicationException

    ' private variable for OS Version property
     Private m_OSVersion As String = Environment.OSVersion.ToString()

    ' default constructor
    Public Sub New()
        MyBase.New()
    End Sub

    'constructor with exception message
    Public Sub New(ByVal message As String)
        MyBase.New(message)
    End Sub

    ' constructor with message and inner exception
    Public Sub New(ByVal message As String, ByVal inner As Exception)
        MyBase.New(message, inner)
    End Sub

    Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New(info, context)
        m_OSVersion = info.GetString("m_OSVersion")
    End Sub

    <SecurityPermission(SecurityAction.Demand, SerializationFormatter:=True)> _
    Public Overrides Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        ' Serialize this class' state and then call the base class GetObjectData
        info.AddValue("m_OSVersion", m_OSVersion, GetType(String))
        MyBase.GetObjectData(info, context)
    End Sub

    ' ReadOnly OS Version property
    Public ReadOnly Property OSVersion()
        Get
            Return m_OSVersion
        End Get

    End Property

End Class
