' Exception Management Quick Start Samples.
' Demonstrates how application exceptions, such as 
' file not found can be handled by ExceptionManager.
' Please see app.config for ExceptionManager configuration settings.
Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents label2 As System.Windows.Forms.Label
    Friend WithEvents label1 As System.Windows.Forms.Label
    Friend WithEvents txtPassword As System.Windows.Forms.TextBox
    Friend WithEvents txtUserName As System.Windows.Forms.TextBox
    Friend WithEvents btnLogon As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.label2 = New System.Windows.Forms.Label()
Me.label1 = New System.Windows.Forms.Label()
Me.txtPassword = New System.Windows.Forms.TextBox()
Me.txtUserName = New System.Windows.Forms.TextBox()
Me.btnLogon = New System.Windows.Forms.Button()
Me.SuspendLayout()
'
'label2
'
Me.label2.Location = New System.Drawing.Point(18, 56)
Me.label2.Name = "label2"
Me.label2.Size = New System.Drawing.Size(104, 16)
Me.label2.TabIndex = 9
Me.label2.Text = "Password: "
Me.label2.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'label1
'
Me.label1.Location = New System.Drawing.Point(18, 24)
Me.label1.Name = "label1"
Me.label1.Size = New System.Drawing.Size(104, 16)
Me.label1.TabIndex = 8
Me.label1.Text = "User Name: "
Me.label1.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'txtPassword
'
Me.txtPassword.Location = New System.Drawing.Point(130, 56)
Me.txtPassword.Name = "txtPassword"
Me.txtPassword.PasswordChar = Microsoft.VisualBasic.ChrW(42)
Me.txtPassword.Size = New System.Drawing.Size(144, 20)
Me.txtPassword.TabIndex = 7
Me.txtPassword.Text = "password"
'
'txtUserName
'
Me.txtUserName.Location = New System.Drawing.Point(130, 24)
Me.txtUserName.Name = "txtUserName"
Me.txtUserName.Size = New System.Drawing.Size(144, 20)
Me.txtUserName.TabIndex = 6
Me.txtUserName.Text = "Fred"
'
'btnLogon
'
Me.btnLogon.Location = New System.Drawing.Point(130, 88)
Me.btnLogon.Name = "btnLogon"
Me.btnLogon.TabIndex = 5
Me.btnLogon.Text = "Logon"
'
'Form1
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(424, 229)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.label2, Me.label1, Me.txtPassword, Me.txtUserName, Me.btnLogon})
Me.Name = "Form1"
Me.Text = "Exception Management Quick Start Samples"
Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    ' Performs logon with information provided
    Private Function DoLogon(ByVal userName As String, ByVal password As String) As Boolean
        Try
            ' attempt to open a text file to vefity user logon and password
            Dim fs As FileStream = New FileStream("Accounts.dat", FileMode.Open, FileAccess.Read)
            Return CheckUserDetails(fs, userName, password)

        Catch ex As FileNotFoundException
            ' file not found, throw a custom LogonException
            Throw New LogonException("Internal Logon Failure. User file not found", ex)
        End Try
    End Function

    ' Simulation that will "read" user information from file
    Private Function CheckUserDetails(ByRef fs As FileStream, ByVal username As String, ByVal password As String) As Boolean
        Return True
    End Function

    Private Sub btnLogon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogon.Click
        ' attempt to log in with information provided by the user
        Try
            If DoLogon(txtUserName.Text, txtPassword.Text) = True Then
                MessageBox.Show("Your Logon Was Successful")
            Else
                MessageBox.Show("Logon failed. Invalid user name or password")
            End If
        Catch lex As LogonException
            ' publish Exception using ExceptionManager
            ExceptionManager.Publish(lex)
            MessageBox.Show(lex.Message)
        End Try
    End Sub
End Class
