using System;
using System.Drawing;
#region Do It Yourself Chapter 6
namespace Photo_Editor_Application
{
    /// <summary>
    /// The LineComponent class implements the
    /// functionality to draw a line into the picture.
    /// </summary>
    /// <requirement>F:image_graphics_annotations</requirement>
    public class LineComponent : GraphicsComponent
    {
        /// <summary>
        /// Constructor for the Line Component.
        /// </summary>
        public LineComponent()
        {

        }

        /// <summary>
        /// Draws the line into the provided Graphics object.
        /// </summary>
        public override void Draw()
        {
            DeviceContext.DrawLine(Pens.Black, CalcViewportCoords(StartPoint), CalcViewportCoords(EndPoint));
        }
		
        /// <summary>
        /// Not used implemented by Picture class.
        /// </summary>
        /// <param name="comp">The component itself.</param>
        public override void Add(GraphicsComponent comp){}

        /// <summary>
        /// Not used, implemented by the Picture Class
        /// </summary>
        /// <param name="comp">The component itself.</param>
        public override void Remove(GraphicsComponent comp){}
		
    }
}
#endregion