using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.ApplicationBlocks.ExceptionManagement;

namespace Photo_Editor_Application
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class PhotoEditorForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.MainMenu MainMenu;
        private System.Windows.Forms.MenuItem FileMenu;
        private System.Windows.Forms.MenuItem OpenFile;
        
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        /// <summary>
        /// Holds a custom scrollable control object.
        /// </summary>
        public CustomScrollableControl.CustomScrollableControl customScrollableControl;
        private System.Windows.Forms.TabControl tabControl;
        private System.Windows.Forms.TabPage basicImageOperations;
        private System.Windows.Forms.Button cropImageButton;
        private System.Windows.Forms.Button flipVerticalButton;
        private System.Windows.Forms.Button flipHorizontalButton;
        private System.Windows.Forms.Button rotateClockButton;
        private System.Windows.Forms.Button rotateCClockButton;
        private System.Windows.Forms.MenuItem saveMenu;
        private System.Windows.Forms.TabPage Overlays;
        /// <summary>
        /// Holds a Picture Object.
        /// </summary>
        public Picture PictureObject;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Button RectangleButton;
        private System.Windows.Forms.Button CircleButton;
        private System.Windows.Forms.Button ROIButton;
        private System.Windows.Forms.Button EraseButton;
        private System.Windows.Forms.Button LineButton;
        private System.Windows.Forms.Button TextButton;
        private System.Windows.Forms.Button ApplyButton;
        private System.Windows.Forms.Button ResetButton;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem2;
        
        // Get the directory in which the application was started.
        private static string applicationDirectory = Application.StartupPath;
        
        /// <summary>
        /// Accessor to the Application directory.
        /// </summary>
        public static string GetApplicationDirectory
        {
            get
            {
                return applicationDirectory;
            }
        }
        private TextBoxInput inputTextBox;
        /// <summary>
        /// Constructor.
        /// </summary>
        public PhotoEditorForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            
            PictureObject = new Picture();
            //sets the private property to not drawing
            isDrawing = false;

            // Sets the static property of the Component to the
            // Graphics object of the window it is drawn in
            GraphicsComponent.DeviceContext = customScrollableControl.CreateGraphics();  
            // Create TextBoxInput to get the input text
            inputTextBox = new TextBoxInput();
        }
        /// <summary>
        /// Custom paint method.
        /// </summary>
        protected override void OnPaint(PaintEventArgs e)
        {
            try
            {
                Graphics deviceContext = e.Graphics;
          
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        } 

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PhotoEditorForm));
            this.MainMenu = new System.Windows.Forms.MainMenu();
            this.FileMenu = new System.Windows.Forms.MenuItem();
            this.OpenFile = new System.Windows.Forms.MenuItem();
            this.saveMenu = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.customScrollableControl = new CustomScrollableControl.CustomScrollableControl();
            this.tabControl = new System.Windows.Forms.TabControl();
            this.basicImageOperations = new System.Windows.Forms.TabPage();
            this.rotateCClockButton = new System.Windows.Forms.Button();
            this.flipHorizontalButton = new System.Windows.Forms.Button();
            this.rotateClockButton = new System.Windows.Forms.Button();
            this.flipVerticalButton = new System.Windows.Forms.Button();
            this.cropImageButton = new System.Windows.Forms.Button();
            this.Overlays = new System.Windows.Forms.TabPage();
            this.ResetButton = new System.Windows.Forms.Button();
            this.ApplyButton = new System.Windows.Forms.Button();
            this.TextButton = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.RectangleButton = new System.Windows.Forms.Button();
            this.CircleButton = new System.Windows.Forms.Button();
            this.EraseButton = new System.Windows.Forms.Button();
            this.ROIButton = new System.Windows.Forms.Button();
            this.LineButton = new System.Windows.Forms.Button();
            this.tabControl.SuspendLayout();
            this.basicImageOperations.SuspendLayout();
            this.Overlays.SuspendLayout();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // MainMenu
            // 
            this.MainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.FileMenu});
            // 
            // FileMenu
            // 
            this.FileMenu.Index = 0;
            this.FileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.OpenFile,
                                                                                     this.saveMenu,
                                                                                     this.menuItem1,
                                                                                     this.menuItem2});
            this.FileMenu.Text = "&File";
            // 
            // OpenFile
            // 
            this.OpenFile.Index = 0;
            this.OpenFile.Text = "&Open File";
            this.OpenFile.Click += new System.EventHandler(this.OpenFile_Click);
            // 
            // saveMenu
            // 
            this.saveMenu.Index = 1;
            this.saveMenu.Text = "&Save as ...";
            this.saveMenu.Click += new System.EventHandler(this.saveMenu_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 2;
            this.menuItem1.Text = "-";
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 3;
            this.menuItem2.Text = "Exit";
            this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
            // 
            // customScrollableControl
            // 
            this.customScrollableControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.customScrollableControl.Location = new System.Drawing.Point(0, 0);
            this.customScrollableControl.Name = "customScrollableControl";
            this.customScrollableControl.ScrollingImage = null;
            this.customScrollableControl.ScrollingImageArea = new System.Drawing.Rectangle(0, 0, 828, 463);
            this.customScrollableControl.Size = new System.Drawing.Size(845, 480);
            this.customScrollableControl.TabIndex = 0;
            this.customScrollableControl.Load += new System.EventHandler(this.customScrollableControl_Load);
            this.customScrollableControl.MouseUp += new System.Windows.Forms.MouseEventHandler(this.customScrollableControl_MouseUp);
            this.customScrollableControl.Paint += new System.Windows.Forms.PaintEventHandler(this.customScrollableControl_Paint);
            this.customScrollableControl.MouseEnter += new System.EventHandler(this.customScrollableControl_MouseEnter);
            this.customScrollableControl.MouseMove += new System.Windows.Forms.MouseEventHandler(this.customScrollableControl_MouseMove);
            this.customScrollableControl.MouseLeave += new System.EventHandler(this.customScrollableControl_MouseLeave);
            this.customScrollableControl.MouseDown += new System.Windows.Forms.MouseEventHandler(this.customScrollableControl_MouseDown);
            // 
            // tabControl
            // 
            this.tabControl.Controls.Add(this.basicImageOperations);
            this.tabControl.Controls.Add(this.Overlays);
            this.tabControl.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.tabControl.Location = new System.Drawing.Point(0, 481);
            this.tabControl.Name = "tabControl";
            this.tabControl.SelectedIndex = 0;
            this.tabControl.Size = new System.Drawing.Size(844, 203);
            this.tabControl.TabIndex = 1;
            // 
            // basicImageOperations
            // 
            this.basicImageOperations.Controls.Add(this.rotateCClockButton);
            this.basicImageOperations.Controls.Add(this.flipHorizontalButton);
            this.basicImageOperations.Controls.Add(this.rotateClockButton);
            this.basicImageOperations.Controls.Add(this.flipVerticalButton);
            this.basicImageOperations.Controls.Add(this.cropImageButton);
            this.basicImageOperations.Location = new System.Drawing.Point(4, 25);
            this.basicImageOperations.Name = "basicImageOperations";
            this.basicImageOperations.Size = new System.Drawing.Size(836, 174);
            this.basicImageOperations.TabIndex = 0;
            this.basicImageOperations.Text = "Basic Image Operations";
            // 
            // rotateCClockButton
            // 
            this.rotateCClockButton.Image = ((System.Drawing.Image)(resources.GetObject("rotateCClockButton.Image")));
            this.rotateCClockButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.rotateCClockButton.Location = new System.Drawing.Point(307, 102);
            this.rotateCClockButton.Name = "rotateCClockButton";
            this.rotateCClockButton.Size = new System.Drawing.Size(163, 26);
            this.rotateCClockButton.TabIndex = 4;
            this.rotateCClockButton.Text = "Rotate CClockwise";
            this.rotateCClockButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.rotateCClockButton.Click += new System.EventHandler(this.rotateCClockButton_Click);
            // 
            // flipHorizontalButton
            // 
            this.flipHorizontalButton.Image = ((System.Drawing.Image)(resources.GetObject("flipHorizontalButton.Image")));
            this.flipHorizontalButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.flipHorizontalButton.Location = new System.Drawing.Point(154, 102);
            this.flipHorizontalButton.Name = "flipHorizontalButton";
            this.flipHorizontalButton.Size = new System.Drawing.Size(124, 26);
            this.flipHorizontalButton.TabIndex = 3;
            this.flipHorizontalButton.Text = "Flip Horizontal";
            this.flipHorizontalButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.flipHorizontalButton.Click += new System.EventHandler(this.flipHorizontalButton_Click);
            // 
            // rotateClockButton
            // 
            this.rotateClockButton.Image = ((System.Drawing.Image)(resources.GetObject("rotateClockButton.Image")));
            this.rotateClockButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.rotateClockButton.Location = new System.Drawing.Point(307, 55);
            this.rotateClockButton.Name = "rotateClockButton";
            this.rotateClockButton.Size = new System.Drawing.Size(163, 27);
            this.rotateClockButton.TabIndex = 2;
            this.rotateClockButton.Text = "Rotate Clockwise";
            this.rotateClockButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.rotateClockButton.Click += new System.EventHandler(this.rotateClockButton_Click);
            // 
            // flipVerticalButton
            // 
            this.flipVerticalButton.Image = ((System.Drawing.Image)(resources.GetObject("flipVerticalButton.Image")));
            this.flipVerticalButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.flipVerticalButton.Location = new System.Drawing.Point(154, 55);
            this.flipVerticalButton.Name = "flipVerticalButton";
            this.flipVerticalButton.Size = new System.Drawing.Size(124, 27);
            this.flipVerticalButton.TabIndex = 1;
            this.flipVerticalButton.Text = "Flip Vertical";
            this.flipVerticalButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.flipVerticalButton.Click += new System.EventHandler(this.flipVerticalButton_Click);
            // 
            // cropImageButton
            // 
            this.cropImageButton.Image = ((System.Drawing.Image)(resources.GetObject("cropImageButton.Image")));
            this.cropImageButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.cropImageButton.Location = new System.Drawing.Point(19, 55);
            this.cropImageButton.Name = "cropImageButton";
            this.cropImageButton.Size = new System.Drawing.Size(115, 27);
            this.cropImageButton.TabIndex = 0;
            this.cropImageButton.Text = "Crop Image";
            this.cropImageButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.cropImageButton.Click += new System.EventHandler(this.cropImageButton_Click);
            // 
            // Overlays
            // 
            this.Overlays.Controls.Add(this.ResetButton);
            this.Overlays.Controls.Add(this.ApplyButton);
            this.Overlays.Controls.Add(this.TextButton);
            this.Overlays.Controls.Add(this.groupBox1);
            this.Overlays.Location = new System.Drawing.Point(4, 25);
            this.Overlays.Name = "Overlays";
            this.Overlays.Size = new System.Drawing.Size(836, 174);
            this.Overlays.TabIndex = 1;
            this.Overlays.Text = "Graphics and Text";
            // 
            // ResetButton
            // 
            this.ResetButton.Location = new System.Drawing.Point(712, 88);
            this.ResetButton.Name = "ResetButton";
            this.ResetButton.Size = new System.Drawing.Size(90, 26);
            this.ResetButton.TabIndex = 12;
            this.ResetButton.Text = "Reset";
            this.ResetButton.Click += new System.EventHandler(this.ResetButton_Click);
            // 
            // ApplyButton
            // 
            this.ApplyButton.Location = new System.Drawing.Point(712, 48);
            this.ApplyButton.Name = "ApplyButton";
            this.ApplyButton.Size = new System.Drawing.Size(90, 27);
            this.ApplyButton.TabIndex = 11;
            this.ApplyButton.Text = "Apply";
            this.ApplyButton.Click += new System.EventHandler(this.ApplyButton_Click);
            // 
            // TextButton
            // 
            this.TextButton.Location = new System.Drawing.Point(376, 48);
            this.TextButton.Name = "TextButton";
            this.TextButton.Size = new System.Drawing.Size(90, 27);
            this.TextButton.TabIndex = 10;
            this.TextButton.Text = "Text";
            this.TextButton.Click += new System.EventHandler(this.TextButton_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.RectangleButton);
            this.groupBox1.Controls.Add(this.CircleButton);
            this.groupBox1.Controls.Add(this.EraseButton);
            this.groupBox1.Controls.Add(this.ROIButton);
            this.groupBox1.Controls.Add(this.LineButton);
            this.groupBox1.Location = new System.Drawing.Point(19, 18);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(336, 120);
            this.groupBox1.TabIndex = 5;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Graphic Overlays";
            // 
            // RectangleButton
            // 
            this.RectangleButton.Location = new System.Drawing.Point(19, 28);
            this.RectangleButton.Name = "RectangleButton";
            this.RectangleButton.Size = new System.Drawing.Size(90, 26);
            this.RectangleButton.TabIndex = 0;
            this.RectangleButton.Text = "Rectangle";
            this.RectangleButton.Click += new System.EventHandler(this.RectangleButton_Click);
            // 
            // CircleButton
            // 
            this.CircleButton.Location = new System.Drawing.Point(19, 74);
            this.CircleButton.Name = "CircleButton";
            this.CircleButton.Size = new System.Drawing.Size(90, 26);
            this.CircleButton.TabIndex = 6;
            this.CircleButton.Text = "Circle";
            this.CircleButton.Click += new System.EventHandler(this.CircleButton_Click);
            // 
            // EraseButton
            // 
            this.EraseButton.Location = new System.Drawing.Point(125, 46);
            this.EraseButton.Name = "EraseButton";
            this.EraseButton.Size = new System.Drawing.Size(90, 27);
            this.EraseButton.TabIndex = 8;
            this.EraseButton.Text = "Erase";
            this.EraseButton.Click += new System.EventHandler(this.EraseButton_Click);
            // 
            // ROIButton
            // 
            this.ROIButton.Location = new System.Drawing.Point(230, 74);
            this.ROIButton.Name = "ROIButton";
            this.ROIButton.Size = new System.Drawing.Size(90, 26);
            this.ROIButton.TabIndex = 7;
            this.ROIButton.Text = "ROI";
            this.ROIButton.Click += new System.EventHandler(this.ROIButton_Click);
            // 
            // LineButton
            // 
            this.LineButton.Location = new System.Drawing.Point(230, 28);
            this.LineButton.Name = "LineButton";
            this.LineButton.Size = new System.Drawing.Size(90, 26);
            this.LineButton.TabIndex = 9;
            this.LineButton.Text = "Line";
            this.LineButton.Click += new System.EventHandler(this.LineButton_Click);
            // 
            // PhotoEditorForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.ClientSize = new System.Drawing.Size(844, 684);
            this.Controls.Add(this.tabControl);
            this.Controls.Add(this.customScrollableControl);
            this.Menu = this.MainMenu;
            this.Name = "PhotoEditorForm";
            this.Text = "Photo Editor Application";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.tabControl.ResumeLayout(false);
            this.basicImageOperations.ResumeLayout(false);
            this.Overlays.ResumeLayout(false);
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new PhotoEditorForm());
        }

        /// <summary>
        /// Called if the Load menu item was selected. Calls LoadImage on Picture class.
        /// </summary>
        private void OpenFile_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.LoadImage();
                if(PictureObject.LoadedImage == null) 
                    throw(new Exception("Error, image could not beloaded"));
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }

        }
        /// <summary>
        /// Method used to set the image displayed in the
        /// custom control to the current picture object image.
        /// Invalidates the custom control. 
        /// </summary>
        public void DisplayImage()
        {
            customScrollableControl.ScrollingImage = PictureObject.LoadedImage;
            customScrollableControl.Invalidate();
            PictureObject.Draw();
        }
       
        /// <summary>
        /// Opens theCrop Dialog box window to allow the user to specify
        /// a new image size. The image will be cropped to the width and
        /// height where the cropped image is taken from the middle of the 
        /// original image.
        /// </summary>
        /// <param name="sender">A reference to the object calling this method</param>
        /// <param name="e">The event arguments provided by the event handler</param>
        private void cropImageButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                CropDialog openDialog = new CropDialog(this);
                if(openDialog == null) 
                    throw(new Exception("Error, CropDialog could not be allocated"));
                openDialog.Show();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        
        /// <summary>
        /// Calls the RoatateFlipImage method of the Image class
        /// </summary>
        private void flipHorizontalButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.RotateNoneFlipX);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        
        }
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void flipVerticalButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.RotateNoneFlipY);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void rotateClockButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.Rotate90FlipNone);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        
        }
        /// <summary>
        /// Calls the RotateFlipImage method of the Image class
        /// </summary>
        private void rotateCClockButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                PictureObject.RotateFlipImage(RotateFlipType.Rotate270FlipNone);
                DisplayImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }
        
        /// <summary>
        /// Calls the SaveImage() method of the Image class
        /// </summary>
        private void saveMenu_Click(object sender, System.EventArgs e)
        {   
            try
            {
                PictureObject.SaveImage();
            }
            catch(Exception exception)
            {
                ExceptionManager.Publish(exception);
            }
        }

        /// <summary>
        /// Convenience method to reset all buttons to
        /// default appearance and to reset toolSelected.
        /// </summary>
        private void resetButtons()
        {
            // Resets all the implemented graphic tool buttons 
            RectangleButton.FlatStyle = FlatStyle.Standard;
            TextButton.FlatStyle = FlatStyle.Standard;
            LineButton.FlatStyle = FlatStyle.Standard;
            CircleButton.FlatStyle = FlatStyle.Standard;
            ROIButton.FlatStyle = FlatStyle.Standard;
            EraseButton.FlatStyle = FlatStyle.Standard;
            

            // Resets the tool currently used to none.
            toolSelected = toolSelection.None;

           
        }
#region Do It Yourself Chapter 6
        // All possible tools that can be selected
        private enum toolSelection { None = 0, RectangleTool, 
            LineTool, CircleTool, ROITool, TextTool, SelectTool}
#endregion
        // Currently tool selected
        private toolSelection toolSelected;

        /// <summary>
        /// Sets the selected tool to RactangleTool if no tool
        /// was selected before. If a tool was selected before
        /// then the tool selection is reset to no tool.
        /// </summary>
        /// <param name="sender">Object that sent the event.</param>
        /// <param name="e">Parameters provided by the event.</param>
        private void RectangleButton_Click(object sender, System.EventArgs e)
        {
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.RectangleTool;
                // Changes the appearance of the button to show it 
                // is actually selected
                RectangleButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
        }

        // Indicates that if a tool was selected, the mouse button was 
        // selected
        // and is not released yet => currently drawing the selected 
        // component
        private bool isDrawing;

        // The selected component that is currently drawing
        private GraphicsComponent compObject;
        private GraphicsComponent regionComponent;
        // If tool was selected and mouse is clicked in the window 
        // then
        // create the component initialize the variables and draw 
        // everything.
        private void customScrollableControl_MouseDown(
            object sender, 
            System.Windows.Forms.MouseEventArgs e)
        {
            // Just go here if tool is not textTool
            if(toolSelected != toolSelection.TextTool)
            {
                // Check if tool is selected and drawing and it is not the select tool.
                if(!isDrawing && (toolSelected != toolSelection.None))
                {
                    switch(toolSelected)
                    {
                            #region Do It Yourself Chapter 6
                            //create component according to tool selected
                        case toolSelection.LineTool:
                            compObject = new LineComponent();
                            break;
                        case toolSelection.RectangleTool:
                            compObject = new RectangleComponent();
                            break;
                            #endregion
                        case toolSelection.CircleTool:
                            compObject = new CircleComponent();
                            break;
                        case toolSelection.ROITool:
                            compObject = new ROIComponent();
                            regionComponent = compObject;
                            break;
                            #region Do It Yourself Chapter 6
                        case toolSelection.SelectTool:
                            compObject = null;
                            compObject = (GraphicsComponent)PictureObject.PositionIsComponent(e.X + 
                                customScrollableControl.ViewportCoords().X, 
                                e.Y + customScrollableControl.ViewportCoords().Y);
                            if(compObject != null)
                            {
                                PictureObject.Remove(compObject);
                            }
                            break;
                            #endregion
                        default:
                            toolSelected = toolSelection.None;
                            throw(new Exception("Error, Tool selected not implemented"));
                    }
                    
                    if((toolSelected != toolSelection.SelectTool) && (toolSelected != toolSelection.None))
                    {
                        // Set the Graphics referenced in the component to the window object.
                        GraphicsComponent.DeviceContext = customScrollableControl.CreateGraphics();
                        // Add the component to the list that needs to be drawn.
                        PictureObject.Add(compObject);
                        // Get the coordinates and 
                        // transform them to coordinates 
                        // relative to the image
                        Point tempPoint = new Point(e.X + customScrollableControl.ViewportCoords().X, 
                            e.Y + customScrollableControl.ViewportCoords().Y);
                        // Set the points
                        compObject.StartPoint = tempPoint;
                        compObject.EndPoint = tempPoint;
					
                        // Now we started drawing a component
                        isDrawing = true;
                    }
                }
            }
            else
            {
                // Create component
                compObject = new TextComponent();
                // Set Graphics object to the customScrollableControl
                GraphicsComponent.DeviceContext = customScrollableControl.CreateGraphics();
                Point tempPoint = new Point(e.X + customScrollableControl.ViewportCoords().X, e.Y + customScrollableControl.ViewportCoords().Y);
                compObject.StartPoint = tempPoint;
                compObject.EndPoint = tempPoint;
                // Show the text input box
                inputTextBox.Show();
                // Register the callback function
                inputTextBox.CallMethod(new TextBoxInput.Feedback(MyEventHandler));	
            }
        }

        // Delegate example for callback function.
        void MyEventHandler(string text)
        {
            TextComponent texC = (TextComponent) compObject;
            texC.TextInput = inputTextBox.TextInput;

            //Add Component to list
            PictureObject.Add(compObject);
			
            //Display everything
            DisplayImage();
        }
    
        // Event Handler for mouse move, 
        // draws component when in draw mode.
        private void customScrollableControl_MouseMove(object 
            sender, System.Windows.Forms.MouseEventArgs e)
        {
            // Check if there was a tool selected.
            if(toolSelected != 0)
            {
                // Change cursor to cross shape.
                Cursor.Current = Cursors.Cross;
            }

            // Check if in drawing mode.
            if(isDrawing)
            {
                // Set new coordinate of endpoint for component 
                // in 
                // coordinates relative to the image.
                Point tempPoint = new Point(e.X + customScrollableControl.ViewportCoords().X, e.Y + customScrollableControl.ViewportCoords().Y);
                compObject.EndPoint = tempPoint;
                
                // Draw everything
                DisplayImage();
            }
            if(toolSelected == toolSelection.SelectTool)
            {
                #region Do It Yourself Chapter 6
                const int delta = 10;
                compObject = null;
                compObject = (GraphicsComponent)PictureObject.PositionIsComponent(e.X + customScrollableControl.ViewportCoords().X, 
                    e.Y + customScrollableControl.ViewportCoords().Y);
				
                if(compObject != null)
                {
                    // if an object is picked, then draw the red rectagles around its start and end points to indicate
                    // the picking
                    Graphics myDC = customScrollableControl.CreateGraphics();
                    Point tempPoint = new Point(compObject.StartPoint.X - 5, compObject.StartPoint.Y - 5);
                    tempPoint = compObject.CalcViewportCoords(tempPoint);
                    myDC.DrawRectangle(Pens.Red, tempPoint.X, tempPoint.Y, delta, delta);

                    tempPoint.X = compObject.EndPoint.X - 5;
                    tempPoint.Y = compObject.EndPoint.Y - 5;
                    tempPoint = compObject.CalcViewportCoords(tempPoint);
                    myDC.DrawRectangle(Pens.Red, tempPoint.X, tempPoint.Y, delta, delta);
					
                }
                else
                {
                    // Draw everything
                    DisplayImage();
                }
                #endregion
            }
        }

        // If mouse button is released and drawing mode then 
        // add object to list and redraw everything
        private void customScrollableControl_MouseUp(object 
            sender, System.Windows.Forms.MouseEventArgs e)
        {
            if(isDrawing)
            {
                // Update endpoint to final position relative to image 
                Point tempPoint = new Point(e.X + customScrollableControl.ViewportCoords().X, e.Y + customScrollableControl.ViewportCoords().Y);
                compObject.EndPoint = tempPoint;
                
                // If ROI tool remove now from List...
                if(toolSelected == toolSelection.ROITool)
                {
                    PictureObject.Remove(compObject);
                }

                // Reset mode to not drawing
                isDrawing = false;

                // Display all
                DisplayImage();
                
            }
        }

    
        // If mouse enters control and a tool is selected
        // than change the cursor to cross
        private void customScrollableControl_MouseEnter(object 
            sender, System.EventArgs e)
        {
            if(toolSelected != 0)
            {
                Cursor.Current = Cursors.Cross;
            }
        }

        // If mouse leaves control make sure 
        // mouse pointer is standard
        private void customScrollableControl_MouseLeave(
            object sender, System.EventArgs e)
        {
            Cursor.Current = Cursors.Default;
        }

        /// <summary>
        /// Text Button was clicked and dialog is poped up for text input.
        /// </summary>
        private void TextButton_Click(object sender, System.EventArgs e)
        {
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.TextTool;
                // Changes the appearance of the button to show it 
                // is actually selected
                TextButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
        
        }

        /// <summary>
        /// Overwrites the pait method. Updates the viewport coords and draws the graphic overlays.
        /// </summary>
        private void customScrollableControl_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            // First update the viewport Coordinates.
            GraphicsComponent.ViewportCoords = customScrollableControl.ViewportCoords();
            // Draw all graphic components.
            PictureObject.Draw();
            
        }
        /// <summary>
        /// Line tool is selected.
        /// </summary>
        private void LineButton_Click(object sender, System.EventArgs e)
        {
            #region Do It Yourself Chapter 6
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.LineTool;
                // Changes the appearance of the button to show it 
                // is actually selected
                LineButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
            #endregion
        }

        /// <summary>
        /// Circle tool is selected.
        /// </summary>
        private void CircleButton_Click(object sender, System.EventArgs e)
        {
            #region Do It Yourself Chapter 6
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.CircleTool;
                // Changes the appearance of the button to show it 
                // is actually selected
                CircleButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
            #endregion
        }

        /// <summary>
        /// ROI tool selected.
        /// </summary>
        private void ROIButton_Click(object sender, System.EventArgs e)
        {
            #region Do It Yourself Chapter 6
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.ROITool;
                // Changes the appearance of the button to show it 
                // is actually selected
                ROIButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
            #endregion
        }

        /// <summary>
        /// Erase button sets selection tool.
        /// </summary>
        private void EraseButton_Click(object sender, System.EventArgs e)
        {
            if(toolSelected == toolSelection.None)
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
                toolSelected = toolSelection.SelectTool;
                // Changes the appearance of the button to show it 
                // is actually selected
               EraseButton.FlatStyle = FlatStyle.Flat;
            }
            else 
            {
                // Calls the convenience method to 
                // reset the buttons to no tool selected.
                resetButtons();
            }  
        
        }
       #region Do It Yourself Chapter 6
        /// <summary>
        /// Applies the graphic overlays by burning them into the image. 
        /// Burning done
        /// in picture class.
        /// </summary>
        private void ApplyButton_Click(object sender, System.EventArgs e)
        {
            PictureObject.ApplyPictureComponents();
            resetButtons();
        }

        /// <summary>
        /// Reset button, resets to the original loaded image. 
        /// Functionality in Picture class is called.
        /// </summary>
        private void ResetButton_Click(object sender, System.EventArgs e)
        {
            PictureObject.Reset();
            DisplayImage();
        }
       #endregion          
        /// <summary>
        /// Exit button pressed, close application.
        /// </summary>
        private void menuItem2_Click(object sender, System.EventArgs e)
        {
            // Just get out of here....
            this.Close();
        }

        private void customScrollableControl_Load(object sender, System.EventArgs e)
        {
            DisplayImage();
        }
   
    }
}
